# Go API client for entrypoints

## Overview

EntryPoint is one of the ways to start interaction flow. It can be represented as QR code, link (https://slace.me/... URL) or NFC tag.

## Data

EntryPoints contain two types of data: 

- **static** - *\"internal\" data storage which can be updated only via editing the EntryPoint* (directly or via Interaction)
- **dynamic** - *public data which can be altered also via query parameters of the EP link. Should NOT be used for secrets or critical data* because it can be overwritten by the end user.

Both data containers are copied to transaction created when EntryPoint is entered. This data is used primarily for personalization or flow control of the Interaction.

## EP Batches

EntryPoints can be batch-created (superadmin feature) and then [assigned](https://slace.stoplight.io/docs/stoplight-docs-core/altekzonwbrq9-imports-uploads#assignment-xlsx) to specific Interactions.

> EntryPoints in a batch have random hashes but it's possible to mass-create EPs using the assignment feature (only superadmins). If a value from **Link hash** column is not found it will be auto-created. This allows to create EntryPoints following different hash pattern (e.g. with common prefix).

EntryPoints are re-assignable meaning that they can be re-used for other Interactions even in another Channel or Organization by another [assignment import](https://slace.stoplight.io/docs/stoplight-docs-core/altekzonwbrq9-imports-uploads#assignment-xlsx).

## Redirects

There is a special type of EntryPoint which does not start a SLACE Interaction but redirects to a configured URL.

## Overview
This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [OpenAPI-spec](https://www.openapis.org/) from a remote server, you can easily generate an API client.

- API version: 1.0
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.GoClientCodegen

## Installation

Install the following dependencies:

```shell
go get github.com/stretchr/testify/assert
go get golang.org/x/net/context
```

Put the package under your project folder and add the following in import:

```golang
import entrypoints "bitbucket.org/_SLACE_/clients/go/entrypoints"
```

To use a proxy, set the environment variable `HTTP_PROXY`:

```golang
os.Setenv("HTTP_PROXY", "http://proxy_name:proxy_port")
```

## Configuration of Server URL

Default configuration comes with `Servers` field that contains server objects as defined in the OpenAPI specification.

### Select Server Configuration

For using other server than the one defined on index 0 set context value `sw.ContextServerIndex` of type `int`.

```golang
ctx := context.WithValue(context.Background(), entrypoints.ContextServerIndex, 1)
```

### Templated Server URL

Templated server URL is formatted using default variables from configuration or from context value `sw.ContextServerVariables` of type `map[string]string`.

```golang
ctx := context.WithValue(context.Background(), entrypoints.ContextServerVariables, map[string]string{
	"basePath": "v2",
})
```

Note, enum values are always validated and all unused variables are silently ignored.

### URLs Configuration per Operation

Each operation can use different server URL defined using `OperationServers` map in the `Configuration`.
An operation is uniquely identified by `"{classname}Service.{nickname}"` string.
Similar rules for overriding default operation server index and variables applies by using `sw.ContextOperationServerIndices` and `sw.ContextOperationServerVariables` context maps.

```golang
ctx := context.WithValue(context.Background(), entrypoints.ContextOperationServerIndices, map[string]int{
	"{classname}Service.{nickname}": 2,
})
ctx = context.WithValue(context.Background(), entrypoints.ContextOperationServerVariables, map[string]map[string]string{
	"{classname}Service.{nickname}": {
		"port": "8443",
	},
})
```

## Documentation for API Endpoints

All URIs are relative to *https://ep.slace.com/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*BatchesJobsAPI* | [**GetManagementEntryPointsJobs**](docs/BatchesJobsAPI.md#getmanagemententrypointsjobs) | **Get** /management/entry-points/jobs | Get batches jobs list
*BatchesJobsAPI* | [**PostManagementEntryPointsJobIdFileGenerationRetry**](docs/BatchesJobsAPI.md#postmanagemententrypointsjobidfilegenerationretry) | **Post** /management/entry-points/{job_id}/file-generation-retry | Retry job file generation
*BatchesJobsAPI* | [**PostManagementEntryPointsJobsJobIdDownload**](docs/BatchesJobsAPI.md#postmanagemententrypointsjobsjobiddownload) | **Post** /management/entry-points/jobs/{job_id}/download | Download ordered batch file from job
*DefaultAPI* | [**ExportEntrypoints**](docs/DefaultAPI.md#exportentrypoints) | **Get** /management/entry-points/export | Export pre-filtered EntryPoints
*EntryPointsAPI* | [**CreateEntryPoint**](docs/EntryPointsAPI.md#createentrypoint) | **Post** /management/entry-points | Create Entry Point
*EntryPointsAPI* | [**CreateSimpleEntryPoint**](docs/EntryPointsAPI.md#createsimpleentrypoint) | **Post** /channels/{channel_id}/entry-points | Create Entry Point
*EntryPointsAPI* | [**DeleteBatchesJobWithRelatedData**](docs/EntryPointsAPI.md#deletebatchesjobwithrelateddata) | **Delete** /management/entry-points/jobs/{job_id} | Delete batches job with related data
*EntryPointsAPI* | [**DeleteEntryPoint**](docs/EntryPointsAPI.md#deleteentrypoint) | **Delete** /management/entry-points/{id} | Delete Entry Point
*EntryPointsAPI* | [**FileRefreshJob**](docs/EntryPointsAPI.md#filerefreshjob) | **Post** /management/entry-points/jobs/{jobId}/file-refresh | Refresh batches job file
*EntryPointsAPI* | [**GetEntryPoint**](docs/EntryPointsAPI.md#getentrypoint) | **Get** /management/entry-points/{id} | Get Entry Point
*EntryPointsAPI* | [**ListEntryPoints**](docs/EntryPointsAPI.md#listentrypoints) | **Get** /management/entry-points | List Entry Points
*EntryPointsAPI* | [**PostEntryPointsOrgId**](docs/EntryPointsAPI.md#postentrypointsorgid) | **Post** /entry-points/{orgId} | Create entry point admin
*EntryPointsAPI* | [**UpdateEntryPoint**](docs/EntryPointsAPI.md#updateentrypoint) | **Put** /management/entry-points/{id} | Update Entry Point
*EntryPointsAPI* | [**UpdateExistingEntryPoint**](docs/EntryPointsAPI.md#updateexistingentrypoint) | **Patch** /channels/{channel_id}/entry-points/{id} | Update Entry Point
*EntryPointsAPI* | [**UpdateInteractionAssignment**](docs/EntryPointsAPI.md#updateinteractionassignment) | **Post** /management/entry-points/assignment/interaction | Assign entry points to another interaction
*OrderedBatchesAPI* | [**CreateOrderedBatch**](docs/OrderedBatchesAPI.md#createorderedbatch) | **Post** /management/ordered-batch | Create Ordered Batch
*OrderedBatchesAPI* | [**ListOrderedBatches**](docs/OrderedBatchesAPI.md#listorderedbatches) | **Get** /management/ordered-batch | List Ordered Batches
*OrderedBatchesAPI* | [**OrderBatchesV2**](docs/OrderedBatchesAPI.md#orderbatchesv2) | **Post** /management/ordered-batch-v2 | Order batches v2
*OrderedBatchesAPI* | [**PostManagementEntryPointsAssignmentV2**](docs/OrderedBatchesAPI.md#postmanagemententrypointsassignmentv2) | **Post** /management/entry-points/assignment-v2 | Ordered batches assignment v2
*OrderedBatchesAPI* | [**PostManagementEntryPointsDataImportV2**](docs/OrderedBatchesAPI.md#postmanagemententrypointsdataimportv2) | **Post** /management/entry-points/data-import-v2 | Data import ordered batches v2


## Documentation For Models

 - [AdminEntryPoint](docs/AdminEntryPoint.md)
 - [AdminEntryPointMutable](docs/AdminEntryPointMutable.md)
 - [AdminEntryPointNewData](docs/AdminEntryPointNewData.md)
 - [AdminEntryPointType](docs/AdminEntryPointType.md)
 - [AdminEntryPointsList](docs/AdminEntryPointsList.md)
 - [BatchesJob](docs/BatchesJob.md)
 - [EntryPoint](docs/EntryPoint.md)
 - [EntryPointData](docs/EntryPointData.md)
 - [EntryPointType](docs/EntryPointType.md)
 - [GenericResponse](docs/GenericResponse.md)
 - [GenericResponseErrors](docs/GenericResponseErrors.md)
 - [GetManagementEntryPointsJobs200Response](docs/GetManagementEntryPointsJobs200Response.md)
 - [InteractionAssignmentRequest](docs/InteractionAssignmentRequest.md)
 - [OrderBatchesV2Request](docs/OrderBatchesV2Request.md)
 - [OrderedBatch](docs/OrderedBatch.md)
 - [OrderedBatchCreateRequest](docs/OrderedBatchCreateRequest.md)
 - [UpdateEntryPointRequest](docs/UpdateEntryPointRequest.md)


## Documentation For Authorization


Authentication schemes defined for the API:
### BearerToken

- **Type**: HTTP Bearer token authentication

Example

```golang
auth := context.WithValue(context.Background(), sw.ContextAccessToken, "BEARER_TOKEN_STRING")
r, err := client.Service.Operation(auth, args)
```


## Documentation for Utility Methods

Due to the fact that model structure members are all pointers, this package contains
a number of utility functions to easily obtain pointers to values of basic types.
Each of these functions takes a value of the given basic type and returns a pointer to it:

* `PtrBool`
* `PtrInt`
* `PtrInt32`
* `PtrInt64`
* `PtrFloat`
* `PtrFloat32`
* `PtrFloat64`
* `PtrString`
* `PtrTime`

## Author



